
/* Generated by Interface Builder */

#import <objc/Object.h>
#import <appkit/nextstd.h>	/* gets stdio */
#import <appkit/publicWraps.h>  /* for NXBeep */
#import <appkit/Form.h>		/* for NXCoord, etc. */

typedef struct {
    char  *filename;
    NXCoord *x;
    NXCoord *y;
    NXCoord *z;
    int   jmax;
    int   kmax;
    int   lmax;
    NXPoint gridmin;
    NXPoint gridmax;
} grid_hunk;

typedef struct {
    char  *filename;
    NXCoord *rho;
    NXCoord *rhou;
    NXCoord *rhov;
    NXCoord *rhow;
    NXCoord *e;
    NXCoord *pressure;
    NXCoord *mach_number;
    int   jmax;
    int   kmax;
    int   lmax;
    NXCoord fsmach;
    NXCoord alpha;
    NXCoord re;
    NXCoord time;
} solution_hunk;

typedef struct {
  NXCoord *x;
  NXCoord *y;
  int jmax;
  int kmax;
  NXPoint gridmin;
  NXPoint gridmax;
} grid_part;

typedef struct {
  NXCoord *x;
  NXCoord *y;
  NXCoord *f;
  int jmax;
  int kmax;
  NXPoint gridmin;
  NXPoint gridmax;
  NXCoord functionmin;
  NXCoord functionmax;
} function_part;

@interface Contour:Object
{
    id  animate3DOnOff;
    id	mainTitle;		/* the main title object */
    id  changeTitleFont;	/* the change title font on/off button */
    id  changeLabelFont;	/* the change label font on/off button */
    id  openPanel;
    id	fMax;
    id	fMin;
    id	yMax;
    id	xMax;
    id	yMin;
    id	xMin;
    id	canvas;
    id	zoomOnOff;
    id	lFunctionMax;
    id	kFunctionMax;
    id	jFunctionMax;
    id	lFunctionMin;
    id	kFunctionMin;
    id	jFunctionMin;
    id	lFunctionInc;
    id	kFunctionInc;
    id	jFunctionInc;
    id	functionMatrix;
    id	plotButton;
    id	lGridInc;
    id	kGridInc;
    id	jGridInc;
    id	lGridMin;
    id	kGridMin;
    id	jGridMin;
    id	lGridMax;
    id	kGridMax;
    id	jGridMax;
    id  contourMin;
    id  contourMax;
    id  contourInc;
    id  numberContours;
    id  autoContours;
    id  drawFunction;
    id  drawGrid;
    id  clearPlot;
    id gridLineThickness;
    id gridLineColor;
    id contourLineThickness;
    id solidContourLines;
    id chooseGridPlane;
    id chooseFunctionPlane;
    id viewingTransformations;
    id setAspectRatio;
    id contourLineColor;
    id xyLabelsOn;
    id unitsLabelOn;
    id contourValuesOn;
    int contourNumber;
    NXCoord *contourLevels;
    const char *maintitle;
    grid_hunk gridhunk;
    solution_hunk solnhunk;
    grid_part gridH;
    function_part functionH;
    NXPoint oldMin;
    NXPoint oldMax;
    BOOL switch2D3D;
    BOOL moreThanOneFunction;
    int beepError;
    BOOL stateChangeGrid;
    BOOL stateChangeFunction;
}

+ new;

- (BOOL) doAnimate;
- (BOOL) doSetAspectRatio;
- (BOOL) do2D3D;
- (BOOL) doZoom;
- (BOOL) doDrawFunction;
- (BOOL) doDrawGrid;
- (BOOL) doClearPlot;
- (BOOL) doSolidLines;
- (BOOL) shouldChangeTitleFont;
- (BOOL) shouldChangeLabelFont;
- (BOOL) shouldShowXYLabels;
- (BOOL) shouldShowUnitsLabel;
- (BOOL) shouldShowContourValues;
- (NXCoord) provideFsmach;
- (NXCoord) provideAlpha;
- (NXCoord) provideRe;
- (NXCoord) provideTime;
- (const char *) provideMainTitle;
- (float) provideGridLineThickness;
- (float) provideContourLineThickness;
- (int) provideGridLineColor;
- (int) provideContourLineColor;
- (function_part) provideFunction:sender;
- (grid_part) provideGrid:sender;
- (int) provideContourNumber:sender;
- (NXCoord *) provideContourLevels:sender;
- (int) provideViewingChoice:sender;
- (int) provideFunctionChoice:sender;
- (int)checkMinMax;

- makeContourLevels:sender;
- drawPlot:sender;
- drawPlotButton:(int)state;
- set2DData:sender;
- set3DData:sender;
- set3DSingle:sender;
- set2DSingle:sender;
- whyTheBeep:sender;

- resetAll:sender;
- resetProjectionData:sender;
- resetGridData:sender;
- resetFunctionData:sender;
- resetFunctionGridMinMax:sender;
- resetGridMinMax:sender;
- resetMinMax:sender;
- resetFunctionMinMax:sender;
- resetGridSubsets:sender;
- resetFunctionSubsets:sender;

- findGridMinAndMax;
- findFunctionMinAndMax;
- findFunctionGridMinAndMax;
- (NXCoord)provideXmin;
- (NXCoord)provideXmax;
- (NXCoord)provideYmin;
- (NXCoord)provideYmax;
- (NXCoord)provideFmin;
- (NXCoord)provideFmax;
- (NXCoord)provideContourmin;
- (NXCoord)provideContourmax;
- (NXCoord)provideContourinc;

- resetCmin:(NXCoord)x;
- resetCmax:(NXCoord)x;
- resetCinc:(NXCoord)x;
- resetFmin:(NXCoord)x;
- resetFmax:(NXCoord)x;
- resetXmin:(NXCoord)x;
- resetXmax:(NXCoord)x;
- resetYmin:(NXCoord)x;
- resetYmax:(NXCoord)x;


- openGrid:sender;
- openSolution:sender;
- readGrid:(NXStream *)aDataStream :(char *)dataFile;
- readSoln:(NXStream *)aDataStream :(char *)dataFile;
- openGridFile:(char *)dataFile;
- openSolnFile:(char *)dataFile;

- loadGrid:sender;
- loadFunction:sender;
- loadFunctionGrid:sender;

@end

